/* 
 * File:   Queue.cpp
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Implementation for Queue (see header file for description)
 * 
 * Based on LinkedList, which was created on January 11, 2013, 3:32 PM
 */

#include "Queue.h"

//**BIG THREE**
//default constructor
Queue::Queue() {
    _head = NULL;//a train without any cars
}

//copy constructor (not defined)
Queue::Queue(const Queue& orig) {
}

//virtual destructor (not defined)
Queue::~Queue() {
}

//**PUBLIC UTILITIES**
//add a leaf at the end of the Queue (FIFO)
void Queue::append(TreeNode* leaf){
    QueueNode* newNode = new QueueNode();//create new node
    newNode->setLeaf(leaf);//set its data
    if (_head == NULL)//we're just starting up the chain
    {
        _head = newNode;
    }
    else //we're adding onto the chain, so find the end of the chain
    {
        QueueNode* runner = _head;
        QueueNode* trailer = NULL;
        while(runner != NULL) //while he hasn't fallen off the back of the train
        {
            //move onto the next node
            trailer = runner;
            runner = runner->getNext();
        }
        
        //now, attach the new car to the end of the train
        trailer->setNext(newNode);
    }
}

//combined get and delete for first leaf (FIFO)
TreeNode* Queue::getDeleteFirst(){
    QueueNode* firstNode = _head;
    TreeNode* firstLeaf = _head->getLeaf();
    _head = _head->getNext();
    delete firstNode;
    return firstLeaf;
}

//report if Queue is empty
bool Queue::isEmpty(){
    if (_head == NULL)
    {
        return true;
    }
    else
    {
        return false;    
    }
}

//count the stored leaves
int Queue::count(){
    int leaves = 0;
    QueueNode* node = _head;
    while (node != NULL)//while we haven't fallen off the back of the train
    {
        node = node->getNext();
        leaves ++;
    }
    return leaves;
}
