/* 
 * File:   Queue.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a Queue. It is the means to access QueueNodes that store
 * TreeNodes (leaves). Can be used as a FIFO (first-in, first-out) structure.
 *
 * Based on LinkedList, which was created on January 11, 2013, 3:32 PM
 */

#ifndef QUEUE_H
#define	QUEUE_H

#include <iostream>
#include "QueueNode.h"

class Queue {
public:
    //big three
    Queue();//default constructor
    Queue(const Queue& orig);//copy constructor (not defined)
    virtual ~Queue();//virtual destructor (not defined)
    
    //public utilities
    void append(TreeNode* leaf);//add a leaf at the end (FIFO)
    TreeNode* getDeleteFirst();//combined get and delete for first leaf (FIFO)
    bool isEmpty();//report if Queue is empty
    int count();//count the stored leaves
private:
    QueueNode* _head;//start of the train
};

#endif	/* QUEUE_H */
