/* 
 * File:   StackNode.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a StackNode. It is the means to store standard strings
 *  in a Stack, keeping them doubly linked.
 * 
 * Based on earlier StackNode, which was created January 31, 2013, 9:45 AM
 */

#ifndef STACKNODE_H
#define	STACKNODE_H

#include <cstdio>
#include <string>

//a member of a Stack, holds standard strings
class StackNode {
public:
    //big three
    StackNode(std::string text);//constructor
    StackNode(const StackNode& orig);//copy constructor (not defined)
    virtual ~StackNode();//virtual destructor (not defined)
    
    //public utilities
    //get pointer to next node
    StackNode* getNext();
    //set pointer to next node
    void setNext(StackNode* next);
    
    //get pointer to previous node
    StackNode* getPrevious();    
    //set pointer to previous node
    void setPrevious(StackNode* previous);
    
    //get text
    std::string getText();
private:
    std::string _text;//string stored in the node
    StackNode* _next;//pointer to next node
    StackNode* _previous;//pointer to previous node
};

#endif	/* STACKNODE_H */
