/* 
 * File:   TreeNode.cpp
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Implementation for TreeNode (see header file for description)
 * 
 * Created on March 7, 2013, 5:28 PM
 */

#include "TreeNode.h"

//**BIG THREE**
//constructor for pseudoNodes/roots
TreeNode::TreeNode(){
    _key = "";
    _left = NULL;
    _right = NULL;
    _parent = NULL;
    _rightSpawn = false;
}

//constructor for normal use (if root, make 'parent' null)
TreeNode::TreeNode(std::string key, TreeNode* left,
        TreeNode* right, TreeNode* parent, bool rightSpawn) {
    _key = key;
    _left = left;
    _right = right;
    _parent = parent;
    _rightSpawn = rightSpawn;
}

//copy constructor (not defined)
TreeNode::TreeNode(const TreeNode& orig) {
}

//virtual destructor (not defined)
TreeNode::~TreeNode() {
}

//**ACCESSORS**
//get the key
std::string TreeNode::getKey(){
    return _key;
}

//get the pointer to the left node
TreeNode* TreeNode::getLeft(){
    return _left;
}

//get the pointer to the right node
TreeNode* TreeNode::getRight(){
    return _right;
}

//get the pointer to the parent node
TreeNode* TreeNode::getParent(){
    return _parent;
}

bool TreeNode::isRightSpawn(){
    return _rightSpawn;
}

//**MUTATORS**
//set the key
void TreeNode::setKey(std::string key){
    _key = key;
}

//set the pointer to the left node
void TreeNode::setLeft(TreeNode* left){
    _left = left;
}

//set the pointer to the right node
void TreeNode::setRight(TreeNode* right){
    _right = right;
}

//set the pointer to the parent node
void TreeNode::setParent(TreeNode* parent){
    _parent = parent;
}

//set if the node is off a right branch of its parent
void TreeNode::setRightSpawn(bool rightSpawn){
    _rightSpawn = rightSpawn;
}
